extern crate ledb;

#[macro_use]
extern crate neon;

extern crate neon_serde;

#[macro_use]
mod helper;
mod collection;
mod documents;
mod storage;

use collection::JsCollection;
use documents::JsDocuments;
use ledb::Storage;
use neon::prelude::*;
use neon_serde::to_value;
use storage::JsStorage;

fn list_openned_storages(mut cx: FunctionContext) -> JsResult<JsValue> {
    let list = js_try!(cx, Storage::openned());
    Ok(js_try!(cx, to_value(&mut cx, &list)))
}

#[no_mangle]
pub extern "C" fn node_addon_init() {
    __LOAD_NEON_MODULE();
}

register_module!(mut cx, {
    cx.export_function("openned", list_openned_storages)?;
    cx.export_class::<JsStorage>("Storage")?;
    cx.export_class::<JsCollection>("Collection")?;
    cx.export_class::<JsDocuments>("Documents")?;
    Ok(())
});
